#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dlfcn.h>

void* _p_knihovna = nullptr;

size_t vypis_text(const char* text) noexcept
{
	typedef size_t (*vypis_text_t)(const char*);
	vypis_text_t p_vypis_text = (vypis_text_t)dlsym(_p_knihovna, "vypis_text");
	if (!p_vypis_text)
	{
		printf("Chyba získání funkce: %s", dlerror());
		return 0;
	}
	return p_vypis_text(text);
}

bool vrat_text() noexcept
{
	typedef bool (*vrat_text_t)(char*, size_t);
	vrat_text_t p_vrat_text = (vrat_text_t)dlsym(_p_knihovna, "vrat_text");
	if (!p_vrat_text)
	{
		printf("Chyba získání funkce: %s", dlerror());
		return false;
	}
	char buff[255];
	bool bret = p_vrat_text(buff, sizeof(buff));
	printf("vrácený text: %s\n", buff);
	return bret;
}

int main (int argc, char *argv[])
{
	_p_knihovna = dlopen("./knihovna.so", RTLD_LAZY);
	if (!_p_knihovna)
	{
		printf("Chyba načtení knihovny: %s", dlerror());
		return EXIT_FAILURE;
	}
	vypis_text("ahoj");
	vrat_text();
	if (0 != dlclose(_p_knihovna))
	{
		printf("Chyba uvolnění knihovny: %s", dlerror());
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}